----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity IO_Module1 is
    Port ( Clk :       	in  STD_LOGIC;
			  out_port :  	in  STD_LOGIC_VECTOR (7 downto 0);
           in_port :   	out STD_LOGIC_VECTOR (7 downto 0);
			  Write_strobe,
			  Read_strobe:    STD_LOGIC;
			  Port_ID :   	in  STD_LOGIC_VECTOR (7 downto 0);
			  ------------------------------------------------
           Segm :      	out STD_LOGIC_VECTOR (1 to 8);
           An :        	out STD_LOGIC_VECTOR (3 downto 0);
           Led :      inout STD_LOGIC_VECTOR (7 downto 0);
			  Timer_Scale:	out STD_LOGIC_VECTOR (7 downto 0);   -- Scale for Timer
           Sw :        	in  STD_LOGIC_VECTOR (7 downto 0);
			  Btn :       	in  STD_LOGIC_VECTOR (3 downto 0));
end IO_Module1;

architecture Behavioral of IO_Module1 is
---------------------------------------------------------------------------
--	type   PCM_Array is array (0 to 7) of std_logic_vector( 7 downto 0);
--	signal PCM: 			PCM_Array;
--	signal PPM_Scale:   std_logic_vector( 7 downto 0);
--	signal PPM_Leds_on: std_logic_vector( 7 downto 0);

---------------------------------------Display signals---------------------
	Signal Clk_1kHz:      std_logic;
	Signal Bcd_ciffer:    std_logic_vector( 3 downto 0);
	Signal Decimal_Punkt: std_logic;
	Signal Segmenter:     std_logic_vector( 1 to 7);
	signal Bcd:           std_logic_vector(15 downto 0);
	signal Dp: 				 std_logic_vector( 3 downto 0);	
---------------------------------------------------------------------------
	signal A,B:				STD_LOGIC_VECTOR ( 7 downto 0); 
	signal AxB: 			STD_LOGIC_VECTOR (15 downto 0); 
			
	COMPONENT muxdisplay_ver3
	PORT(
		Clk_50MHz : IN  std_logic;
		Bcd : 		IN  std_logic_vector(15 downto 0);
		Dp : 			IN  std_logic_vector(3 downto 0);          
		Segm : 		OUT std_logic_vector(1 to 8);
		An : 			OUT std_logic_vector(3 downto 0);
		Clk_1kHz : 	OUT std_logic
		);
	END COMPONENT;	
---------------------------------------------------------------------------
begin

	Inst_muxdisplay_ver3: muxdisplay_ver3 PORT MAP(
		Clk_50MHz=> Clk,
		Bcd => 		Bcd,
		Dp =>  		Dp,
		Segm => 		Segm ,
		An => 		An,
		Clk_1kHz => Clk_1kHz
	);
  
	AxB <= A * B;
  ------------------------------------------------------------------------
  -- KCPSM3 input ports 
  ------------------------------------------------------------------------
  input_ports: process(clk)
  begin
     if clk'event and clk='1' then
--	     if Read_strobe='1' then
			  Case conv_integer( Port_id(4 downto 0)) is
					when  0 => in_port <= "0000"& Bcd(  3 downto  0);
					when  1 => in_port <= "0000"& Bcd(  7 downto  4);
					when  2 => in_port <= "0000"& Bcd( 11 downto  8);
					when  3 => in_port <= "0000"& Bcd( 15 downto 12);
					when  4 => in_port <=  Bcd( 7 downto 0);
					when  5 => in_port <=  Bcd(15 downto 8);
					when  6 => in_port <= "0000" & Dp;
					when  7 => in_port <= "00000000";
--					when  8 => in_port <= PPM_Scale;
					when  9 => in_port <= Led;
--					when 10 => in_port <= PPM_Leds_on;
--					when 11 => in_port <= PCM(0);					
--					when 12 => in_port <= PCM(1);
--					when 13 => in_port <= PCM(2);
--					when 14 => in_port <= PCM(3);
--					when 15 => in_port <= PCM(4);
--					when 16 => in_port <= PCM(5);
--					when 17 => in_port <= PCM(6);
--					when 18 => in_port <= PCM(7);				  
				  ------------------------------------------------------
					when 20 => in_port <=  Sw;
					when 21 => in_port <=  "0000"& Btn;
				  ----------------------------------------Multiplier---
				   when 22 => in_port <= AxB( 7 downto 0);
				   when 23 => in_port <= AxB(15 downto 8);					
					when others => null;
			  end case;
--		  end if;
	  end if;
  end process input_ports;

  --------------------------------------------------------------------------
  -- KCPSM3 output ports 
  --------------------------------------------------------------------------
  output_ports: process(clk)
  begin
     if clk'event and clk='1' then
			if write_strobe='1' then
				Case conv_integer( Port_id(4 downto 0)) is
					when  0 => Bcd( 3 downto  0) <= out_port(3 downto 0);
					when  1 => Bcd( 7 downto  4) <= out_port(3 downto 0);
					when  2 => Bcd(11 downto  8) <= out_port(3 downto 0);
					when  3 => Bcd(15 downto 12) <= out_port(3 downto 0);
					when  4 => Bcd( 7 downto  0) <= out_port;
					when  5 => Bcd(15 downto  8) <= out_port;
					when  6 => Dp                <= out_port(3 downto 0);
					when  7 => Timer_Scale 			<= out_port;
--					when  8 => PPM_Scale 			<= out_port;
					when  9 => Led 					<= out_port;
--					when 10 => PPM_Leds_on        <= out_port;
--					when 11 => PCM(0)					<= out_port;					
--					when 12 => PCM(1)					<= out_port;
--					when 13 => PCM(2)					<= out_port;
--					when 14 => PCM(3)					<= out_port;
--					when 15 => PCM(4)					<= out_port;
--					when 16 => PCM(5)					<= out_port;
--					when 17 => PCM(6)					<= out_port;
--					when 18 => PCM(7)					<= out_port;	
               ------------------------------------------Multiplier---
				   when 22 => A  						<= out_port;
				   when 23 => B  						<= out_port;					
					when others => null;
				end case;
			end if;
     end if;
  end process output_ports;

end Behavioral;
